/************************************************************************************************/
/* Database name: TEKNISA_SAAS                                                                  */
/* Tabelas: GER_VERIFICACAO, GER_PARAMVERIFICA                                                  */
/*                                                                                              */
/* Criação:                                                                                     */
/* 03/03/2021 - Vinicius Mayrink                                                                */
/* Objetivo: Inserir validações relativas ao controle de frequência nas validações do sistema   */
/*                                                                                              */
/************************************************************************************************/

/*VERIFICAÇÃO DE MARCAÇÃO*/  
INSERT INTO GER_VERIFICACAO (
    NRVERIFICACAO,
    NRTIPOVERIFICA,
    DSVERIFICACAO,
    MSGVERIFICACAO,
    DSEMAILVERIFICA,
    DSCONSULTAVERIFICA,
    IDATIVO,
    NRORGINCLUSAO,
    DTINCLUSAO,
    CDOPERINCLUSAO,
    NRORGULTATU,
    DTULTATU,
    CDOPERULTATU,
    NRORG,
    DSCONSULTAVERIFICAAUX
) VALUES (
    22,
    2,
    'Dia com quantidade de marcações de ponto ímpares',
    'Dia com quantidade de marcações de ponto ímpares',
    NULL,
    'SELECT * 
FROM (
    SELECT VM.NRVINCULOM || '' - '' || VM.NMVINCULOM AS VINCULO, TO_CHAR(MP.DTHRMARCACAOPONTO, ''DD/MM/YYYY'') AS DATA, COUNT(MP.NRMARCACAOPONTO) QUANTIDADE_MARCACAOES_DIA
    FROM GPE_MARCACAOPONTO          MP
    JOIN GPE_VINCULOM               VM  ON VM.NRORG = MP.NRORG AND VM.NRVINCULOM            = MP.NRVINCULOM
    JOIN PTO_TIPOPERIODOAPURACAO    TP  ON TP.NRORG = MP.NRORG AND TP.NRTIPOVINCULOM        = VM.NRTIPOVINCULOM
    JOIN PTO_PERIODOAPURACAO        P   ON P.NRORG  = MP.NRORG AND P.NRTIPOPERIODOAPURACAO  = TP.NRTIPOPERIODOAPURACAO AND :P_DTMESCOMPETENC BETWEEN P.DTINICIALAPURACAO AND P.DTFINALAPURACAO
    WHERE MP.NRORG = :P_NRORG
        AND MP.DTHRMARCACAOPONTO BETWEEN P.DTINICIALAPURACAO AND P.DTFINALAPURACAO
        AND MP.NRCOLETOR IN (24, 26)
    GROUP BY VM.NRVINCULOM, VM.NMVINCULOM, TO_CHAR(MP.DTHRMARCACAOPONTO, ''DD/MM/YYYY'')
    ORDER BY VM.NMVINCULOM, TO_CHAR(MP.DTHRMARCACAOPONTO, ''DD/MM/YYYY'')
) WHERE MOD(QUANTIDADE_MARCACAOES_DIA, 2) <> 0',
    'S',
    1,
    NULL,
    1,
    1,
    sysdate,
    1,
    1664,
    'SELECT * 
FROM (
    SELECT VM.NRVINCULOM || '' - '' || VM.NMVINCULOM AS VINCULO, TO_CHAR(MP.DTHRMARCACAOPONTO, ''DD/MM/YYYY'') AS DATA, COUNT(MP.NRMARCACAOPONTO) QUANTIDADE_MARCACAOES_DIA
    FROM GPE_MARCACAOPONTO          MP
    JOIN GPE_VINCULOM               VM  ON VM.NRORG = MP.NRORG AND VM.NRVINCULOM            = MP.NRVINCULOM
    JOIN PTO_TIPOPERIODOAPURACAO    TP  ON TP.NRORG = MP.NRORG AND TP.NRTIPOVINCULOM        = VM.NRTIPOVINCULOM
    JOIN PTO_PERIODOAPURACAO        P   ON P.NRORG  = MP.NRORG AND P.NRTIPOPERIODOAPURACAO  = TP.NRTIPOPERIODOAPURACAO AND :P_DTMESCOMPETENC BETWEEN P.DTINICIALAPURACAO AND P.DTFINALAPURACAO
    WHERE MP.NRORG = :P_NRORG
        AND MP.DTHRMARCACAOPONTO BETWEEN P.DTINICIALAPURACAO AND P.DTFINALAPURACAO
        AND MP.NRCOLETOR IN (24, 26)
    GROUP BY VM.NRVINCULOM, VM.NMVINCULOM, TO_CHAR(MP.DTHRMARCACAOPONTO, ''DD/MM/YYYY'')
    ORDER BY VM.NMVINCULOM, TO_CHAR(MP.DTHRMARCACAOPONTO, ''DD/MM/YYYY'')
) WHERE MOD(QUANTIDADE_MARCACAOES_DIA, 2) <> 0'
);
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    22,     
    'P_NRORG',   
    '@\FPA::getNrorgTrabalho()@',            
    'S',                    
    1, 
    NULL,                 
    1,             
    1,
    NULL,                   
    1,               
    1664,
    '@\HCM\Util\FPA::getNrorgTrabalho()@'
);
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    22,     
    'P_DTMESCOMPETENC',   
    '@\FPA::getDtCompetencia()@',            
    'S',                    
    1, 
    NULL,                 
    1,             
    1,
    NULL,                   
    1,               
    1664,
    '@\HCM\Util\FPA::getDtCompetencia()@'
);
/

/*VERIFICAÇÃO DE FALTAS*/  
INSERT INTO GER_VERIFICACAO (
    NRVERIFICACAO,
    NRTIPOVERIFICA,
    DSVERIFICACAO,
    MSGVERIFICACAO,
    DSEMAILVERIFICA,
    DSCONSULTAVERIFICA,
    IDATIVO,
    NRORGINCLUSAO,
    DTINCLUSAO,
    CDOPERINCLUSAO,
    NRORGULTATU,
    DTULTATU,
    CDOPERULTATU,
    NRORG,
    DSCONSULTAVERIFICAAUX
) VALUES (
    23,
    2,
    'Dia apurado como falta',
    'Dia apurado como falta',
    NULL,
    'SELECT RS.NRVINCULOM || '' - '' || VM.NMVINCULOM AS VINCULO, TO_CHAR(RS.DTAPURACAOSITUFREQ, ''DD/MM/YYYY'') AS DATA, TO_CHAR(P.DTINICIALAPURACAO, ''DD/MM/YYYY'') || '' - '' || TO_CHAR(P.DTFINALAPURACAO, ''DD/MM/YYYY'') AS PERIODO, CSF.NRCALCULOSITUFREQ, CSF.DSCALCULOSITUFREQ AS CALCULO
FROM PTO_RESUMOSITUFREQ RS
JOIN      GPE_VINCULOM                  VM  ON VM.NRORG = RS.NRORG AND VM.NRVINCULOM = RS.NRVINCULOM
LEFT JOIN PTO_PERIODOAPURACAO           P   ON P.NRORG = RS.NRORG AND P.NRPERIODOAPURACAO = RS.NRPERIODOAPURACAO
LEFT JOIN PTO_SITUFREQUENCIA            SF  ON (SF.NRORG     = 0 OR SF.NRORG = RS.NRORG)               AND SF.NRSITUFREQUENCIA         = RS.NRSITUFREQUENCIA
LEFT JOIN PTO_ASSOCSITUFREQ             ASF ON (ASF.NRORG   = RS.NRORG OR ASF.NRORG = 0)               AND ASF.NRSITUFREQUENCIA        = RS.NRSITUFREQUENCIA
LEFT JOIN PTO_CALCULOSITUFREQ           CSF ON CSF.NRCALCULOSITUFREQ = ASF.NRCALCULOSITUFREQ
WHERE RS.NRORG = :P_NRORG
    /*BUSCA POR FALTAS_DIURNAS e FALTAS_NOTURNAS*/
    AND CSF.NRCALCULOSITUFREQ IN (10500, 10600)
    AND RS.NRPERIODOAPURACAO IN (
        SELECT NRPERIODOAPURACAO
        FROM PTO_PERIODOAPURACAO P
        JOIN PTO_TIPOPERIODOAPURACAO TP ON TP.NRORG = P.NRORG AND TP.NRTIPOVINCULOM = VM.NRTIPOVINCULOM
        WHERE P.NRORG = RS.NRORG AND P.NRTIPOPERIODOAPURACAO = TP.NRTIPOPERIODOAPURACAO AND :P_DTMESCOMPETENC BETWEEN P.DTINICIALAPURACAO AND P.DTFINALAPURACAO
    )
ORDER BY VM.NMVINCULOM, RS.DTAPURACAOSITUFREQ',
    'S',
    1,
    NULL,
    1,
    1,
    sysdate,
    1,
    1664,
    'SELECT RS.NRVINCULOM || '' - '' || VM.NMVINCULOM AS VINCULO, TO_CHAR(RS.DTAPURACAOSITUFREQ, ''DD/MM/YYYY'') AS DATA, TO_CHAR(P.DTINICIALAPURACAO, ''DD/MM/YYYY'') || '' - '' || TO_CHAR(P.DTFINALAPURACAO, ''DD/MM/YYYY'') AS PERIODO, CSF.NRCALCULOSITUFREQ, CSF.DSCALCULOSITUFREQ AS CALCULO
FROM PTO_RESUMOSITUFREQ RS
JOIN      GPE_VINCULOM                  VM  ON VM.NRORG = RS.NRORG AND VM.NRVINCULOM = RS.NRVINCULOM
LEFT JOIN PTO_PERIODOAPURACAO           P   ON P.NRORG = RS.NRORG AND P.NRPERIODOAPURACAO = RS.NRPERIODOAPURACAO
LEFT JOIN PTO_SITUFREQUENCIA            SF  ON (SF.NRORG     = 0 OR SF.NRORG = RS.NRORG)               AND SF.NRSITUFREQUENCIA         = RS.NRSITUFREQUENCIA
LEFT JOIN PTO_ASSOCSITUFREQ             ASF ON (ASF.NRORG   = RS.NRORG OR ASF.NRORG = 0)               AND ASF.NRSITUFREQUENCIA        = RS.NRSITUFREQUENCIA
LEFT JOIN PTO_CALCULOSITUFREQ           CSF ON CSF.NRCALCULOSITUFREQ = ASF.NRCALCULOSITUFREQ
WHERE RS.NRORG = :P_NRORG
    /*BUSCA POR FALTAS_DIURNAS e FALTAS_NOTURNAS*/
    AND CSF.NRCALCULOSITUFREQ IN (10500, 10600)
    AND RS.NRPERIODOAPURACAO IN (
        SELECT NRPERIODOAPURACAO
        FROM PTO_PERIODOAPURACAO P
        JOIN PTO_TIPOPERIODOAPURACAO TP ON TP.NRORG = P.NRORG AND TP.NRTIPOVINCULOM = VM.NRTIPOVINCULOM
        WHERE P.NRORG = RS.NRORG AND P.NRTIPOPERIODOAPURACAO = TP.NRTIPOPERIODOAPURACAO AND :P_DTMESCOMPETENC BETWEEN P.DTINICIALAPURACAO AND P.DTFINALAPURACAO
    )
ORDER BY VM.NMVINCULOM, RS.DTAPURACAOSITUFREQ'
);
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    23,     
    'P_NRORG',   
    '@\FPA::getNrorgTrabalho()@',            
    'S',                    
    1, 
    NULL,                 
    1,             
    1,
    NULL,                   
    1,               
    1664,
    '@\HCM\Util\FPA::getNrorgTrabalho()@'
);
/

INSERT INTO GER_PARAMVERIFICA (
    NRPARAMVERIFICA,   
    NRVERIFICACAO,     
    NMPARAMVERIFICA,   
    VRPARAMVERIFICA,            
    IDATIVO,                    
    NRORGINCLUSAO, 
    DTINCLUSAO,                 
    CDOPERINCLUSAO,             
    NRORGULTATU,
    DTULTATU,                   
    CDOPERULTATU,               
    NRORG,
    VRPARAMVERIFICAAUX
) VALUES (
    (SELECT MAX(NRPARAMVERIFICA) + 1 FROM GER_PARAMVERIFICA),   
    23,     
    'P_DTMESCOMPETENC',   
    '@\FPA::getDtCompetencia()@',            
    'S',                    
    1, 
    NULL,                 
    1,             
    1,
    NULL,                   
    1,               
    1664,
    '@\HCM\Util\FPA::getDtCompetencia()@'
);
/